unit SFFile;

interface

Uses Windows;

Type
  TsfPresetHeader = packed record
    PresetName: Array[0..19] of Char;
    wPreset,wBank,wPresetBagNdx: Word;
    dwLibrary,dwGenre,dwMorphology: DWORD;
  end;
  TsfPresetBag = packed record
    wGenNdx,wModNdx: Word;
  end;
  TSFGenerator = Word;
  TrangesType = packed record
    byLo,byHi: Byte;
  end;
  TgenAmountType = packed record
    Case Byte of
    0: (ranges: TrangesType;  );
    1: (shAmount: Smallint;   );
    2: (wAmount: Word;        );
  end;
  TsfGenList = packed record
    sfGenOper:  TSFGenerator;
    genAmount:  TgenAmountType;
  end;
  TsfInstGenList = TsfGenList;
  TsfInst = packed record
    InstName: Array[0..19] of Char;
    wInstBagNdx: Word;
  end;
  TsfInstBag = packed record
    wInstGenNdx,wInstModNdx: Word;
  end;
  TSFSampleLink = Word;
  TsfSample = packed record
    SampleName:                 Array[0..19] of Char;
    dwStart,dwEnd,dwStartLoop,
    dwEndLoop,dwSampleRate:     DWORD;
    byOriginalPitch:            Byte;
    chPitchCorrection:          Shortint;
    wSampleLink:                Word;
    sfSampleType:               TSFSampleLink;
  end;

Const
  GEN_INSTRUMENT = 41;
  GEN_SAMPLE = 53;

function ListSortCompare(Item1, Item2: Pointer): Integer;
function UnFourCC(CC:Integer):ShortString;
function FourCC(CC:String):Integer;

implementation

function ListSortCompare(Item1, Item2: Pointer): Integer;
begin
Result := Integer(Item1)-Integer(Item2);
end;

function FourCC(CC:String):Integer;
begin
Result := Byte(CC[1]) or (Byte(CC[2]) shl 8) or (Byte(CC[3]) shl 16) or (Byte(CC[4]) shl 24);
end;

function UnFourCC(CC:Integer):ShortString;
var
I:Integer;
begin
SetLength(Result,4);
For I := 1 to 4 do Result[I] := Char((CC shr ((I-1)*8)) and $FF);
end;

end.
